Loading...
Searching...
No Matches
gr::fec::code::repetition_decoder Class Referenceabstract
GNU Radio C++ Signal Processing Blocks » Error Coding and Decoding

Repetition Decoding class. More...

`#include <gnuradio/fec/repetition_decoder.h>`

## Public Member Functions

bool | set_frame_size (unsigned int frame_size) override=0
double | rate () override=0
Public Member Functions inherited from gr::fec::generic_decoder
virtual void | generic_work (const void *inbuffer, void *outbuffer)=0
int | unique_id ()
std::string | alias ()
| generic_decoder (void)
| generic_decoder (std::string name)
virtual | ~generic_decoder ()
virtual int | get_input_size ()=0
virtual int | get_output_size ()=0
virtual int | get_history ()
virtual float | get_shift ()
virtual int | get_input_item_size ()
virtual int | get_output_item_size ()
virtual const char * | get_input_conversion ()
virtual const char * | get_output_conversion ()
virtual float | get_iterations ()

## Static Public Member Functions

static generic_decoder::sptr | make (int frame_size, int rep, float ap_prob=0.5)

## Additional Inherited Members

Public Types inherited from gr::fec::generic_decoder
typedef std::shared_ptr< generic_decoder > | sptr
Public Attributes inherited from gr::fec::generic_decoder
int | my_id
std::string | d_name
Static Public Attributes inherited from gr::fec::generic_decoder
static int | base_unique_id
Protected Attributes inherited from gr::fec::generic_decoder
gr::logger_ptr | d_logger

## Detailed Description

Repetition Decoding class.

A repetition decoder class. This takes a majority vote, biased by the `ap_prob` rate, and decides if the number of 1 bits > ap_prob, it is a 1; else, it is a 0.

## Member Function Documentation

## make()

generic_decoder::sptr gr::fec::code::repetition_decoder::make | ( | int | frame_size,
|  | int | rep,
|  | float | ap_prob = 0.5 )

static

Build a repetition decoding FEC API object.

Parameters

  frame_size | Number of bits per frame. If using in the tagged stream style, this is the maximum allowable number of bits per frame.
  rep | Repetition rate; encoder rate is rep bits out for each input bit.
  ap_prob | The a priori probability that a bit is a 1 (generally, unless otherwise known, assume to be 0.5).

## rate()

double gr::fec::code::repetition_decoder::rate | ( |  | ) |

override pure virtual

Returns the coding rate of this encoder (it will always be 1).

Implements gr::fec::generic_decoder.

## set_frame_size()

bool gr::fec::code::repetition_decoder::set_frame_size | ( | unsigned int | frame_size | ) |

override pure virtual

Sets the uncoded frame size to `frame_size`. If `frame_size` is greater than the value given to the constructor, the frame size will be capped by that initial value and this function will return false. Otherwise, it returns true.

Implements gr::fec::generic_decoder.

The documentation for this class was generated from the following file:

- repetition_decoder.h